package com.css.simulation.resource.system.service;

import api.common.pojo.param.system.ParameterParam;
import api.common.pojo.po.system.ParameterPO;
import api.common.pojo.vo.system.ParameterVO;
import api.common.util.ObjectUtil;
import api.common.util.StringUtil;
import com.css.simulation.resource.common.utils.PageUtil;
import com.css.simulation.resource.common.utils.PoUtil;
import com.css.simulation.resource.system.mapper.ParameterMapper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;


@Service
public class ParameterService {

    @Autowired
    ParameterMapper parameterMapper;


    public PageInfo<ParameterVO> getParameterList(ParameterParam pageParam) {
        PageUtil.setPageInfo(pageParam);
        List<ParameterVO> list = parameterMapper.getParameterList(pageParam);
        return new PageInfo<>(list);
    }


    public ParameterPO saveParameter(ParameterPO paramPO) {
        String id = paramPO.getId();
        if(ObjectUtil.isNotNull(id)){
            // 更新，将原纪录is_deleted置为1
            ParameterPO deleteParamPo = new ParameterPO();
            deleteParamPo.setId(id);
            PoUtil.initDelPo(deleteParamPo);
            parameterMapper.deleteById(deleteParamPo);
        }
        //新增一条纪录
        paramPO.setId(StringUtil.getRandomUUID());
        PoUtil.initAddPo(paramPO);
        parameterMapper.insert(paramPO);
        return paramPO;
    }

    public PageInfo<ParameterVO> getParamHistory(ParameterParam pageParam) {
        PageUtil.setPageInfo(pageParam);
        List<ParameterVO> list = parameterMapper.getParamHistory(pageParam);
        return new PageInfo<>(list);
    }

}
